dnl                                                      -*- Autoconf -*- 
dnl  autoconf macro for the mortran mp2a preprocessor
dnl  Copyright (C) 2004 2005 Patrice Dumas
dnl
dnl  This program is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation; either version 2 of the License, or
dnl  (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

AC_DEFUN([AC_PROG_MORTRAN],[
AC_REQUIRE([AC_PROG_F77])
AC_ARG_VAR([MORTRAN],[Mortran preprocessor command])dnl
AC_ARG_VAR([MTNFLAGS],[Mortran preprocessor flags])dnl
AC_ARG_VAR([MTN],[Mortran executable])dnl
AC_ARG_VAR([MTNDEPEND],[Mortran dependencies tracker executable])dnl
if test -z "$MORTRAN"; then
   AC_CHECK_PROG([MORTRAN],[mortran],[mortran],[no])
fi
if test -z "$MTN"; then
   AC_CHECK_PROG([MTN],[mtn],[mtn])
fi

AC_CACHE_CHECK([for a Mortran preprocessor],
               [mp2a_mortran],
[
echo "program mtn;integer i;end;" | $MORTRAN $MTNFLAGS -o conftest.mf1 >/dev/null 2>&1

MP2A_MTN_RESULT=`cat conftest.mf1`

if test $? = 0; then
    AC_LANG_PUSH(Fortran 77)
    AC_LINK_IFELSE([$MP2A_MTN_RESULT],
    [mp2a_mortran='yes'],
    [mp2a_mortran='no'],[])
    AC_LANG_POP(Fortran 77)
else
    mp2a_mortran='no'
fi
rm -f conftest.mf1
])
AS_IF([test x"$mp2a_mortran" = xyes],
      [m4_default([$1], [MP2A_MORTRAN=$AS_TR_SH(mp2a_mortran)])],
      [
       AC_MSG_WARN([cannot find a mortran preprocessor])
       $2
      ])

dnl MP2A_MORTRAN=$AS_TR_SH(mp2a_mortran)
])

dnl mp2a specific checks
AC_DEFUN([MP2A_CHECK_MP2],[
AC_REQUIRE([AC_PROG_F77])

if test -z "$MTNDEPEND"; then
   AC_CHECK_PROG([MTNDEPEND],[mtndepend],[mtndepend])
fi

AC_CACHE_CHECK([for the Mortran preprocessor style],
               [mp2a_mp2],
[

rm -f conftest.mtn
cat >>conftest.mtn<<_ACEOF
[&C0
&'tab #;'='tab(#1) = #1**2;'
program mtn;integer i,tab(3);do i=1,3 <tab i;>;end;]
_ACEOF

$MORTRAN $MTNFLAGS conftest.mtn -o conftest.mf1 >/dev/null 2>&1

MP2A_MTN_RESULT=`cat conftest.mf1`

if test $? = 0; then
    AC_LANG_PUSH(Fortran 77)
    AC_LINK_IFELSE([$MP2A_MTN_RESULT],
    [mp2a_mp2='yes'],
    [mp2a_mp2='no'],[])
    AC_LANG_POP(Fortran 77)
else
    mp2a_mp2='no'
fi
rm -f conftest.mf1 conftest.mtn
])
AS_IF([test x"$mp2a_mp2" = xyes -a x"$MTNDEPEND" != xno],
      [m4_default([$1], [MP2A_MP2=$AS_TR_SH(mp2a_mp2)])],
      [
       AC_MSG_WARN([cannot find a mp2 compatible mortran preprocessor])
       $4
      ])

dnl MP2A_MP2=$AS_TR_SH(mp2a_mp2)
])

AC_DEFUN([AC_CHECK_MP2],[
mp2a_mp2_ok='no'
AC_PROG_MORTRAN([
    MP2A_CHECK_MP2([mp2a_mp2_ok='yes'],[])
],
[])
AS_IF([test x"$mp2a_mp2_ok" = xyes],
      [$1],
      [$2])
])
